<?php
namespace HCM\AVL\Repository;


use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

class TipoAvaliacaoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }
    
    public function getQuestaoTipoAvaliacao($nrorg, $nrTipoAvaliacao,$nrquestao){
       $query = $this->entityManager->getConnection()->prepare(
            "SELECT * FROM QUESTIPOAVAL NQ 
                    WHERE NQ.NRORG = :P_NRORG
                    AND NQ.NRTIPOAVALIACAO = :NRTIPOAVALIACAO
                    AND NQ.NRQUESTIPOAVAL IN 
                        (SELECT N.NRQUESTIPOAVAL FROM QUESTIPOAVAL N  
                        WHERE N.NRORG = NQ.NRORG 
                        AND N.NRTIPOAVALIACAO = NQ.NRTIPOAVALIACAO
                        AND N.NRQUESTAO = :P_NRQUESTAO
                        )"
        );
        $query->execute(
            array(
                'P_NRORG' => $nrorg,
                'NRTIPOAVALIACAO' => $nrTipoAvaliacao,
                'P_NRQUESTAO' => $nrquestao
            )    
        );
        return $query->fetchAll();
    }
    
    public function getQuestoesTipoAvaliacao($nrorg, $nrTipoAvaliacao){
        $query = $this->entityManager->getConnection()->prepare(
            "SELECT * 
               FROM QUESTIPOAVAL NQ 
              WHERE NQ.NRORG = :P_NRORG
                    AND NQ.NRTIPOAVALIACAO = :P_NRTIPOAVALIACAO"
        );
        $query->execute(
            array("P_NRORG"           => $nrorg,
                  "P_NRTIPOAVALIACAO" => $nrTipoAvaliacao)    
        );
        return $query->fetchAll();
    }
    
}
