<?php
namespace HCM\FPA\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;
use HCM\FPA\Services\LogRetrocessoCalculoService;

class LogRetrocessoCalculoController extends Crud {
    
    protected $parameterBagColumns = array('NRORG', 'NRORG_PADRAO');

    protected $dataSourceName = 'getLogRetrocessoCalc';
    protected $logRetrocessoCalculoService;
    

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters, LogRetrocessoCalculoService $logRetrocessoCalculoService){
        $this->parameterBag    = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        $this->logRetrocessoCalculoService = $logRetrocessoCalculoService;
        parent::__construct($dataSourceManager);
    }
    
    public function persistirLogRetrocesso($tpCalc, $rowForm){
        $this->logRetrocessoCalculoService->persistirLogRetrocesso($tpCalc, $rowForm);
    }

    public function getLogRetrocessoCalc (DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData); 
        $response->addDataSet($dataSet);
    }

    protected function processConditionValue($condition) {
        return $condition['value'];
    }

    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
    }
    

}
