<?php

namespace HCM\FPA\ObrigacaoLegal\Rais;

use HCM\FPA\ObrigacaoLegal\Rais\Entities\Tipo01Base;
use HCM\FPA\Entity\FpatipomovimentEntity;

use HCM\Util\Repositories;
use HCM\Util\FPA;
use HCM\Util\MsgCalculo;
use HCM\FPA\ObrigacaoLegal\Rais\Tipo02;

use Teknisa\Model\Geral\Repositories\Estruturam;
use Teknisa\Model\Gestaopessoas\Repositories\FpaIncidevento;
use Teknisa\Model\Gestaopessoas\Repositories\GpeMovimentacao;
use Teknisa\Model\Gestaopessoas\Repositories\FpaMsgcalculo;



class Tipo01 extends Tipo01Base
{

    private $estruturam;
    private $estruturah;
    private $estrutsind;
    public $tipo02;
    private $vinculos;
    private $nrformrais;
    private $idProjetaRescisao;

    public $idalert;
    public $iderros;
    public $idabort;
    public $mensagens;

    function __construct($hcmParameters,$entityManager,$estruturam, $estruturah, $ano, $centralPag = null, $sindicato = null, $nrformrais, $idProjetaRescisao)
    {
        $this->hcmParameters = $hcmParameters;
        $this->entityManager = $entityManager;
        $this->_buscaDadosFormulario($nrformrais);
        $this->idProjetaRescisao = $idProjetaRescisao;
        $this->ano = $ano;
        $this->estruturam = $estruturam;
        $this->estruturah = $estruturah;
        $this->estrutsind = $sindicato[0];
        $historico = $this->entityManager->getRepository(Repositories::ESTRUTURAH)->retornaEstruturaHistorico($this->hcmParameters->getNrorg(),$this->estrutsind->getNrestruturam(),$this->hcmParameters->getDtCompetencia());
        $this->estrutsind->historico = $historico;
        $this->nrformrais = $nrformrais;
        $this->idalert = false;
        $this->iderros = false;
        $this->idabort = false;
        $default = $this->setDefaultValue();
        $basicInfo = $this->setBasicInfo($estruturam, $estruturah);
        $adressInfo = $this->setAdress();
        $comunInfo = $this->setComunicat();
        $patInfo = $this->setPatInfo();
        $contrInfo = $this->setContrInfo();
    }

    private function setDefaultValue()
    {
        $this->prefixo = '00';
        $this->constante = '0';
        $this->tipoRegistro = 1;
        $this->zeros = '00';
        $this->espacos = '';
        $this->numPropriet = 0;
        $this->contrAssocCnpj = 0;
        $this->contrConfedCnpj = 0;
        $this->contrSindiCnpj = 0;
        $this->contrAssistCnpj = 0;
        $this->centPagSindical = 2;
        $this->centPagSindCnpj = 0;
        $this->empresaFiliSind = 2;
        $this->tipoSisContrPto = '02';
        $this->infoExclEmpresa = '';
        $this->tipoRais = 00;

        return true;
    }

    private function setBasicInfo($estruturam, $estruturah)
    {
        try {
            $final = "31/12/$this->ano";
            $paramsindicato = $this->entityManager->getRepository(Repositories::FPA_PARAMSINDICATO)->getParamSindicato($this->estrutsind->getNrestruturam(),$this->estrutsind->getNrorg(),$final);

            if(!$estruturah){
                throw new \Exception("Nenhuma estrutura foi retornada para o filtro de busca selecionado");
            }

            if (!is_null($estruturah->getCdcnpjestrut())) {
                $this->cnpj = $estruturah->getCdcnpjestrut();
                $this->tipoInscricao = 1;
            } else {
                $this->cnpj = $estruturah->getCdceiestrut();
                $this->tipoInscricao = 3;
            }
            $this->razaoSocial = $estruturah->getNmrazsocestrut();
            $this->cnae = $estruturah->getCdcnae();
            $this->natJuridica = $estruturah->getCdnatujuri();
            $this->matricula = $estruturah->getCdceiestrut();

            if (!$paramsindicato) {
                $params = array(
                    1 => $estruturam->getNrestruturam()
                );
                throw new \Exception("Não foi possível encontrar os parametros do sindicato patronal");
            }
            $this->dataBase = substr($paramsindicato->getDtbasesindical(),3,2);

            if($this->estruturah->getDtextincao() instanceof DateTime ){
                $this->encerramento = '1';
                $this->dataEncerramento = $this->estruturah->getDtextincao()->format('d/m/Y');
                $this->atividadeAno = ($this->estruturah->getDtextincao()->format('Y') >= $this->ano)?'1':'2';
            }elseif(!is_null($this->estruturah->getDtextincao())){
                $this->encerramento = '1';
                $this->dataEncerramento = $this->estruturah->getDtextincao();
                $this->atividadeAno = (substr($this->estruturah->getDtextincao(),6, 4) >= $this->ano)?'1':'2';
            }else{
                $this->encerramento = '2';
                $this->atividadeAno = '1';
            }
            switch($this->estruturah->getIdtipoempr()){
                case('1'):{
                    $this->porte = 1;
                    break;
                }
                case('2'):{
                    $this->porte = 2;
                    break;
                }
                default:{
                    $this->porte = 3;
                    break;
                }
            }
            if($estruturah->getIdoptsimples() == 'S'){
                $this->optSimples = 1;
            }else{
                $this->optSimples = 2;
            }

            return true;

        } catch (Exception $e) {
            throw $e;
        }
    }

    private function setAdress()
    {
        try {
            $endereco = $this->entityManager->getRepository(Repositories::ENDERECOPARC)->findOneBy(
                array(
                'nrparcnegocio' => $this->estruturam->getNrparcnegocio(),
                'nrorg' => $this->estruturam->getNrorg()
                )
            );
            if($endereco){
                $this->logradouro = $endereco->getDsendereco();
                $this->numero = $endereco->getNrimovelendereco();
                $this->complemento = $endereco->getDscompleendereco();
                $this->bairro = $endereco->getNmbairroendereco();
                $this->cep = $endereco->getNrcependereco();
                $this->uf = $endereco->getSgestado();
                if($endereco->getCdmunicipio()){
                    $municipio = $this->entityManager->getRepository(Repositories::MUNICIPIO)->findOneBy(
                        array(
                        "cdmunicipio" => $endereco->getCdmunicipio(),
                        "cdpais" => $endereco->getCdpais(),
                        "sgestado" => $endereco->getSgestado()
                            )
                        );
                    $this->codMunicipio = $municipio->getCdmunicibge();
                    $this->municipio = $municipio->getNmmunicipio();
                }else{
                    $params = array(
                        $this->estruturam->getNrestruturam(),
                        $this->estruturam->getNmestruturam(),
                    );
                    //throw new \Exception("Não foi possível encontrar o municipio para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam());
                    $this->mensagens[] = "Não foi possível encontrar o municipio para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam();
                }
            }else{
                $params = array(
                    $this->estruturam->getNrestruturam(),
                    $this->estruturam->getNmestruturam(),
                );
                //throw new \Exception("Não foi possível encontrar o endereço para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam());
                $this->mensagens[] = "Não foi possível encontrar o endereço para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam();
            }

            return true;

        } catch (Exception $e) {
            throw $e;
        }
    }

    private function setComunicat()
    {
        try {
            $telefone = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findOneBy(
                [
                'nrparcnegocio' => $this->estruturam->getNrparcnegocio(),
                'nrorg' => $this->estruturam->getNrorg(),
                'cdformacomu' => '01'
                ]
            );
            $email = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findOneBy(
                [
                'nrparcnegocio' => $this->estruturam->getNrparcnegocio(),
                'nrorg' => $this->estruturam->getNrorg(),
                'cdformacomu' => '05'
                ]
            );

            if($telefone){
                $this->ddd = substr(str_pad($telefone->getCdprefixcomuparc(),3,'0',STR_PAD_LEFT),1,2);
                $this->numeroTel = $telefone->getCdcomunicaparc();
            }else{
                //throw new \Exception("Não foi possível encontrar o telefone para a estrutura  ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam());
                $this->mensagens[] = "Não foi possível encontrar o telefone para a estrutura  ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam();
            }
            if($email){
                $this->email = $email->getCdcomunicaparc();
            }else{
                $params = array(
                    $this->estruturam->getNrestruturam(),
                    $this->estruturam->getNmestruturam(),
                );
                //throw new \Exception("Não foi possível encontrar o e-mail para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam());
                $this->mensagens[] = "Não foi possível encontrar o e-mail para a estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam();
            }

            return true;
        } catch (Exception $e) {
            throw $e;
        }

    }


    private function setPatInfo()
    {

        if($this->estruturah->getIdparticipat() == 'S'){
            $this->optPat = 1;

            if (is_null($this->patMenos5)) {
                $me5sm = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->getVincSalabaixo5SM($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), $this->ano);
                $this->patMenos5 = $me5sm['qtd'];
            }
            if (is_null($this->patMais5)) {             
                $ma5sm = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->getVincSalAcima5SM($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), $this->ano);
                $this->patMais5 = $ma5sm['qtd'];
            }
            
            if (is_null($this->servicoProp)) {
                $this->servicoProp = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 1, $this->ano);
            }
            if (is_null($this->admCozinha)) {
                $this->admCozinha = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 2, $this->ano);
            }
            if (is_null($this->convenio)) {
                $this->convenio = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 3, $this->ano);
            }
            if (is_null($this->transportadas)) {
                $this->transportadas = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 4, $this->ano);
            }
            if (is_null($this->cesta)) {
                $this->cesta = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 5, $this->ano);
            }
            if (is_null($this->alimentConvenio)) {
                $this->alimentConvenio = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->quantFuncPorPat($this->estruturam->getNrestruturam(), $this->estruturam->getNrorg(), 6, $this->ano);
            }
        }else{
            $this->optPat = 2;

            $this->patMais5 = 0;
            $this->patMenos5 = 0;
            $this->servicoProp = 0;
            $this->admCozinha = 0;
            $this->convenio = 0;
            $this->transportadas = 0;
            $this->cesta = 0;
            $this->alimentConvenio = 0;
        }

        return true;

    }

    private function setContrInfo()
    {
        if ($this->contrSindiValor > 0) {
            $this->contrSindiCnpj = $this->estrutsind->historico->getCdcnpjestrut();
        }
        if ($this->contrAssocValor > 0) {
            $this->empresaFiliSind = 1;
            $this->contrAssocCnpj = $this->estrutsind->historico->getCdcnpjestrut();
        }
        if ($this->contrAssistValor > 0) {
            $this->contrAssistCnpj = $this->estrutsind->historico->getCdcnpjestrut();
        }
        if ($this->contrConfedValor > 0) {
            $this->contrConfedCnpj = $this->estrutsind->historico->getCdcnpjestrut();
        }
    }

    
    public function setRais02($grupoIncidencia, $vinculos) {
        if($vinculos) {
            $nrcalculofolha = FPA::determinaNrCalculoFolha(FpatipomovimentEntity::TP_MOV_MENSAL);
            $this->entityManager->getRepository(Repositories::FPA_MSGCALCULO)->limpaMsgCalculoProcesso($nrcalculofolha, $this->hcmParameters->getNrorgTrabalho(), 'RAIS', $this->hcmParameters->getCdOperador());
            foreach($vinculos as $vinculo) {
                if ($vinculo->getNrtipovinculom() == 1) {
                    MsgCalculo::getInstance()->setDados($nrcalculofolha, $vinculo->getNrvinculom(), $vinculo->getNrorg(), 'RAIS');
                    try {
                        $transferencias = $this->entityManager->getRepository(Repositories::GPE_MOVIMENTACAO)->getMovimentacoesTransferencia(
                            $vinculo->getNrorg(),$this->hcmParameters->getDtCompetencia(), $vinculo->getNrvinculom(), FPA::getTipoEstruturaLegalOrg(), $vinculo->historico->getNrestrutLegal(), '01/01'.$this->ano, '31/12'.$this->ano
                        );
                        if (count($transferencias) > 1) {
                            if ($transferencias[0]->getNrtpmovtransfm() == 9 && $transferencias[1]->getNrtpmovtransfm() == 8) {
                                $this->tipo02[] = new Tipo02($this->hcmParameters,$this->entityManager,$vinculo, $this->ano, $this->estruturah->getCdcnpjestrut(), $grupoIncidencia, $this->nrformrais, 'SAIDA', $this->idProjetaRescisao);
                                $this->tipo02[] = new Tipo02($this->hcmParameters,$this->entityManager,$vinculo, $this->ano, $this->estruturah->getCdcnpjestrut(), $grupoIncidencia, $this->nrformrais, 'RETORNO', $this->idProjetaRescisao);
                            } else {
                                $this->tipo02[] = new Tipo02($this->hcmParameters,$this->entityManager,$vinculo, $this->ano, $this->estruturah->getCdcnpjestrut(), $grupoIncidencia, $this->nrformrais, $this->idProjetaRescisao);
                            }
                        } else {
                            $this->tipo02[] = new Tipo02($this->hcmParameters,$this->entityManager,$vinculo, $this->ano, $this->estruturah->getCdcnpjestrut(), $grupoIncidencia, $this->nrformrais, $this->idProjetaRescisao);
                        }

                    } catch (Exception $e) {
                        if ($e->getCode() == Messages::ERROR_MESSAGE_CODE) {
                            MsgCalculo::getInstance()->adicionaMensagem($e->getMessage(), MsgCalculo::ERRO);
                        } elseif ($e->getCode() == Messages::ALERT_MESSAGE_CODE) {
                            MsgCalculo::getInstance()->adicionaMensagem($e->getMessage());
                        } else {
                            throw $e;
                        }
                    }

                    $msgcalculo = MsgCalculo::getInstance()->getDados();

                    if ($msgcalculo['IDABORT'] === true) {
                        $this->idabort = true;
                        $this->mensagens = $msgcalculo['MENSAGENS'];
                        break;
                    }elseif ($msgcalculo['IDSTATUS'] === MsgCalculo::ID_COM_ERRO) {
                        $this->iderros = true;
                    }elseif ($msgcalculo['IDSTATUS'] === MsgCalculo::ID_COM_ALERTA) {
                        $this->idalert = true;
                    } else {
                        if ($vinculo->getNrtipovinculom() == 3) {
                            $this->numPropriet++;
                        }
                    }
                }
                MsgCalculo::getInstance()->salvaMensagens(true);
                MsgCalculo::getInstance()->clear();
            }
            return $nrcalculofolha;
        }else{
            throw new \Exception("A estrutura ".$this->estruturam->getNrestruturam()."-".$this->estruturam->getNmestruturam()." não possui vínculos");
        }
    }

    public function getTipo02()
    {
        $linhas = array();
        foreach($this->tipo02 as $tipo02){
            $linhas[] = $tipo02->getRow();
        }
        return $linhas;
    }

    public function getInfoZero()
    {
        return array(
            'CNPJ' => $this->cnpj,
            'PREFIXO' => $this->prefixo,
        );
    }

    public function getQuantDois()
    {
        return count($this->tipo02);
    }

    private function _buscaDadosFormulario($nrformrais)
    {
        $formulario = $this->entityManager->getRepository(Repositories::FPA_FORMRAIS)->findOneBy(
            array(
                'nrorg' => $this->hcmParameters->getNrorgTrabalho(),
                'nrformrais' => $nrformrais
                )
        );
        if (is_object($formulario) === true) {
            $this->patMenos5 = $formulario->getNrtrabate5sal();
            $this->patMais5 = $formulario->getNrtrabmai5sal();
            $this->servicoProp = $formulario->getVrpercservprop();
            $this->admCozinha = $formulario->getVrpercadmicozi();
            $this->convenio = $formulario->getVrpercrefeconv();
            $this->transportadas = $formulario->getVrpercrefetran();
            $this->cesta = $formulario->getVrperccestalim();
            $this->alimentConvenio = $formulario->getVrpercalimconv();
            $this->contrSindiValor = $formulario->getVrcontrsindpatr() * 100;
            $this->contrAssocValor = $formulario->getVrcontrassopatr() * 100;
            $this->contrAssistValor = $formulario->getVrcontrassipatr() * 100;
            $this->contrConfedValor = $formulario->getVrcontrconfpatr() * 100;
        } else {
            throw new \Exception("Formulário não encontrado, contate o administrador.");
        }
    }
}
