<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use Teknisa\Libs\Util\Environment;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class OcupacaoService {

    protected $entityManager;
    /** @var Environment */
    protected $environment;

    public function __construct(EntityManager $entityManager, Environment $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function deleteOcupacao($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $ocupacaoh = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOH)->findOneBy(array("nrocupacaom" => $dataset['NROCUPACAOM'], "nrocupacaoh" => $dataset['NROCUPACAOH'],"nrorg" => $dataset['NRORG']));
            $this->entityManager->remove($ocupacaoh);
            $this->entityManager->flush();
            $ocupacaohh = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOH)->findOneBy(array("nrocupacaom" => $dataset['NROCUPACAOM'],"nrorg" => $dataset['NRORG']));
            if(empty($ocupacaohh)) {
                $ocupacaom = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOM)->findOneBy(array("nrocupacaom" => $dataset['NROCUPACAOM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($ocupacaom);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function retornaOcupacao($nrOrg, $nrOcupacaom, $mesCompetencia){
        try{
            /*$ocupacao = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOM)->findOneBy(array("nrocupacaom" => $nrOcupacaom,"nrorg" => $nrOrg));
            if (is_object($ocupacao) === true) {
                $historico = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOH)->findOneBy(array("nrocupacaom" => $nrOcupacaom,"nrorg" => $nrOrg),(array('dtmescompetenc' => 'DESC')));
                $ocupacao->historico = $historico;
            }*/
            $ocupacao = $this->entityManager->getRepository(Repositories::GPE_OCUPACAOM)->retornaOcupacao($nrOrg, $nrOcupacaom, $mesCompetencia);
            return $ocupacao;

        } catch (Exception $e){
            echo $e->getMessage().'<br />';
        }
    }
}